#Arquivo de benefício do par (Projeto, Mes)                                       
from benefit import *                                                             
#Arquivo de validação das Restrições                                              
from constraints import *                                                         
#Modulo Datetime do Python                                                        
#Arquivo Main                                                                     
from main import *                                                                
#Modulo Random do Python                                                          
from random import *                                                              
#Arquivo de Leitura das Entradas do Problema                                      
from reader import *                                                              
#Modulo Math do Python                                                            
import math                                                                       
#Modulo Operator do Python                                                        
import operator                                                                   
#Modulo Sys do Python                                                             
import sys                                                                        
#Modulo Time do Python                                                            
import time                                                                       
#Modulo Timeit do Python                                                          
import timeit                                                                     
                                                                                  
BEST_SOLUTION = {}                                                                
DELTA = 5                                                                         
EPSYLON = 0.000001                                                                
ETA_PROBABILITY = 7                                                               
INFINITY = sys.maxsize                                                            
K = 5                                                                             
POOL_CAPACITY = 20                                                                
POOL_SOLUTIONS = []                                                               
R = 2                                                                             
THE_BEST_SOLUTION = {}                                                            
                                                                                  
########################--CONSTRUTOR DE SOLUÇÃO--############################     
def solution_constructor():                                                       
                                                                                  
    #Mapeia projeto em mes de agendamento                                         
    solution = {}                                                                 
                                                                                  
    global ETA_PROBABILITY                                                        
    global K                                                                      
    global mandatory_project                                                      
    global sorted_benefit_pairs                                                   
                                                                                  
    CL = []                                                                       
    eta = None                                                                    
    HRSP = []                                                                     
    HRSP_length = None                                                            
    the_month = -1                                                                
    the_project = -1                                                              
    SP = []                                                                       
    SP_length = None                                                              
                                                                                  
    #Para cada projeto obrigatorio                                                
    for project in mandatory_project.keys():                                      
        #O Projeto da solução recebe o mês pré agendado                           
        solution[project] = mandatory_project[project]                             
    #end for                                                                      
#########################--CONSTRUTOR DE LISTAS--############################     
    #Para cada par na lista de pares de benefícios                                
    for pair in sorted_benefit_pairs:                                             
        #p recebe um projeto                                                      
        p = pair[1]                                                               
        #Se o projeto controlar o ponto de atenção intoleravel                    
        if p in intolerable_warning_point.keys():                                 
            #É alocado na lista de Alto risco                                     
            HRSP.append(pair)                                                     
        else:                                                                     
            #Se não é alocado na lista dos projetos remanecentes                  
            SP.append(pair)                                                       
        #end if                                                                   
    #end for                                                                      
    #Tamanho de cada lista de Projetos                                            
    HRSP_length = len(HRSP)                                                       
    SP_length = len(SP)                                                           
#########################--CONSTRUTOR DE LISTAS--#####################-END-##     
    #Enquanto o tamanho das listas forem maior que zero                           
    while(HRSP_length != 0 or SP_length != 0):                                     
        if HRSP_length == 0:                                                      
            CL = SP                                                               
        elif SP_length == 0:                                                      
            CL = HRSP                                                             
        else:                                                                     
            #Variavel com a probabilidade de escolha da lista                                                                                  
            eta = randit(1,10)                                                    
            if eta <= ETA_PROBABILITY:                                            
                #Probabilidade de 70%                                                                                  
                CL = HRSP                                                         
            else:                                                                 
                #Probabilidade de 30%                                                                                  
                CL = SP                                                           
            #end if                                                               
        #end if                                                                   
        #Indice aleatório dos projetos da Lista corrente(CL)                                                                                  
        index = (randint(1,min(K,len(CL))) - 1)                                   
        #O par (projeto,mês) recebe o projeto e o mês conforme o index                                                                                  
        the_project = CL[index][0][0]                                                                                  
        the_month = CL[index][0][1]                                               
        #Remove o projeto da lista                                                                                  
        del CL[index]                                                                                  
        HRSP_length = len(HRSP)                                                                                  
        SP_length = len(SP)                                                       
        #Lista temporaria de soluções                                                                                  
        temporary_solution = dict(solution)                                                                                  
                                                                                  
        #Se o projeto não estiver contido na solução                                                                                  
        if the_project not in solution.keys():                                    
            #Ele é adicionado a solução temporária                                                                                  
            temporary_solution[the_project] = the_month                           
            #Se o projeto for válido, é acrescentado à solução                                                                                  
            if is_a_valid_solution(temporary_solution):                           
                solution[the_project] = the_month                                 
            #end if                                                               
        #end if                                                                   
    #end while                                                                    
    return solution                                                               
#end def                                                                                  
########################--CONSTRUTOR DE SOLUÇÃO--#####################-END-##     
###############################--CALCULO DELTA--#############################                                                                                  
def range_delta(month):                                                           
    global DELTA                                                                                  
    global project_duration                                                       
    new_month = 0                                                                                  
    months = []                                                                                  
                                                                                  
    for new_month in range(max(1,(month-DELTA)),(month+DELTA)):                   
        if new_month == month:                                                                                                                                                                                                                        
            continue                                                              
        #end if                                                                   
        for duration in project_duration.keys():                                  
            if (new_month+project_duration[duration]) <= 60:                      
                #Adiciona o Mes em uma lista de possíveis meses para um projeto                                                                                  
                months.append(new_month)                                          
            #end if                                                               
        #end for                                                                  
    #end for                                                                                                                                                        
    return months                                                                 
#end def                                                                                  
###############################--CALCULO DELTA--######################-END-##     
#############################--CALCULO MÊS FINAL--###########################                                                                                  
def last_month(solution,warning_point):                                           
    global project_duration                                                                                  
    global warning_points_hash                                                                                  
                                                                                  
    for warning_point in warning_points_hash.keys():                              
        #Calcula o ultimo mes do ultimo projeto que controla um ponto de atenção                                                                                  
        max_last_month = max( [ (solution[p] + project_duration[p] - 1) for p in warning_points_hash[warning_point]])
    #end for                                                                                  
    return max_last_month                                                                     
#end def                                                                                  
#############################--CALCULO MÊS FINAL--####################-END-##                 
########################--CALCULO FUNÇÃO OBJETIVO--##########################                                                                                  
def objective_function(solution):                                                                                                                                   
    global risk_value_total                                                                                  
    global T                                                                                                                                                                    
    global warning_points_hash                                                                                  
    global warning_point_risk                                                                                  
                                                                                                                                                                    
    if solution == {}:                                                                        
        return INFINITY                                                                       
    #end if                                                                                  
    solved_risk = sum([warning_point_risk[w]*(2*T - last_month(solution,w)) for w in warning_points_hash.keys()])                                                   
    unsolved_risk = (2*T * risk_value_total)                                                                          
    return (unsolved_risk - solved_risk)                                                                              
#end def                                                                                  
########################--CALCULO FUNÇÃO OBJETIVO--###################-END-##                                         
#################################--GRASP--###################################                                                                                  
def GRASP():                                                                                  
    global BEST_SOLUTION                                                                                  
    global POOL_CAPACITY                                                                                  
    global POOL_SOLUTIONS                                                                                  
    global R                                                                                  
    temporary_pool = {}                                                                                  
                                                                                  
    #Número de vezes da execução do Laço                                                                                  
    for x in range(R):                                                            
        BEST_SOLUTION = {}                                                                                  
        POOL_SOLUTIONS = []                                                       
        #Enquanto o número de soluções for menor que a capacidade                                                                                  
        while(len(POOL_SOLUTIONS) < POOL_CAPACITY):                               
            #É dado inicio a fase de Construçao de uma solução.                                                                                  
            P = solution_constructor()                                            
            #Se não violar as de Pontos de Atenção Intoleráveis.                                                                                  
            if(check_intolerable_warning_point(P)):                               
                #Função para salvar soluções                                                                                  
                save_solution(P)                                                  
                #A solução é adicionada ao POOL de soluções                                                                                  
                POOL_SOLUTIONS.append(P)                                          
            #end if                                                               
        #end while                                                                                  
                                                                                  
        #Para cada soluções no POOL de soluções                                                                                  
        for solution in range(len(POOL_SOLUTIONS)):                               
            #É calculada a função objetivo de cada solução                                                                                  
            temporary_pool[solution] = objective_function(POOL_SOLUTIONS[solution])                                                                                  
        #end for                                                                                  
                                                                                  
        #O POOL de soluções é ordenado em ordem crescente de valores                                                                                  
        sorted_pool_solutions = sorted(temporary_pool.items(), key=operator.itemgetter(1))                                                                                  
                                                                                  
        #Incio da Fase de Busca Local                                                                          
        for tupla in sorted_pool_solutions:                                       
            solution = POOL_SOLUTIONS[tupla[0]]                                                                                  
            P = local_search(solution)                                            
            #se o valor da função objetivo do Portfolio for menor que a BEST_SOLUTION                                                                                  
            if objective_function(P) < objective_function(BEST_SOLUTION):         
                #BEST_SOLUTION recebe o Portfolio                                                                                  
                BEST_SOLUTION = P                                                 
            #end if                                                               
        #end for                                                                  
    #end for                                                                      
    return BEST_SOLUTION                                                          
#end def                                                                                  
#################################--GRASP--############################-END-##                 
#############################--BUSCA LOCAL--#################################                                                                                  
def local_search(P):                                                                          
    global EPSYLON                                                                            
    FLAG = False                                                                                  
                                                                                  
    #best_current_solution recebe uma cópia da solução de entrada                                                                                  
    best_current_solution = dict(P)                                                           
    #Laço infinito                                                                                  
    while (0 == 0):                                                                           
        #Para cada vizinho encontrado na best_current_solution                                                                                  
        for neighbor in neighborhood_constructor(best_current_solution):                      
            FLAG = False                                                                      
            #Se a diferença do valor da função objetivo do vizinho pelo valor da função objetivo da best_current_solution for menor que EPSYLON                                                                                  
            if((objective_function(neighbor) - objective_function(best_current_solution)) < EPSYLON):                                                                                  
                #O vizinho passa a ser a best_current_solution                                                                                  
                best_current_solution = neighbor                                  
                FLAG = True                                                       
            #Se não houver mais mudanças                                                                                  
            if not FLAG:                                                          
                #A Busca Local é encerrada                                                                                  
                break                                                             
            #end if                                                               
        #end for                                                                  
        #Se a best_current_solution for igual a solução de entrada                                                                                  
        if (best_current_solution == P or not FLAG):                              
            #A Busca Local é encerrada                                                                                  
            break                                                                 
        #end if                                                                   
    #end while                                                                    
    return best_current_solution                                                  
#end def                                                                                  
#############################--BUSCA LOCAL--##########################-END-##     
###########################-- CONSTRUÇÃO DA VIZINHANÇA--#####################                                                                                  
def neighborhood_constructor(P):                                                  
    neighbor_list = []                                                                                  
    temporary_solution = dict(P)                                                                                  
                                                                                  
    #Para cada projeto da solução                                                                                  
    for project in P.keys():                                                      
        #Para cada mes do horizonte de planejamento na proporção de (5-month e month+5)                                                                                  
        for month in range_delta(P[project]):                                     
            #O projeto é escalonado neste dado mês                                                                                  
            temporary_solution[project] = month                                   
            #Se a alocação não violar nenhuma restrição                                                                                  
            if is_a_valid_solution(temporary_solution) and check_intolerable_warning_point(temporary_solution):                                                                                  
                #A solução é adicionada na vizinhaça do Portfolio P                                                                                  
                neighbor_list.append(temporary_solution)                          
            #end if                                                               
            temporary_solution = dict(P)                                          
        #end for                                                                  
    #end for                                                                      
    return neighbor_list                                                          
#end def                                                                                  
###########################-- CONSTRUÇÃO DA VIZINHANÇA--##############-END-##                                                                                  
#Horario inicial antes da chamada da função                                                                                  
begin = timeit.default_timer()                                                    
#Chamada da função GRASP                                                                                  
THE_BEST_SOLUTION = GRASP()                                                       
#Horario final depois da chamada da função                                                                                  
end = timeit.default_timer()                                                      
#Calculo do tempo de execução da Funcção GRASP                                                                                  
code_execution_time = (end - begin)                                               
print('Limitante Inferior desta entrada:', LOWER_LIMIT, 'Sua Função Objetivo:', objective_function(LOWER_LIMIT),'\n')                                                                                  
print('A melhor Solução encontrada:',THE_BEST_SOLUTION, '\nSua Função Objetivo:',objective_function(THE_BEST_SOLUTION),'\nCom a Duração de:',code_execution_time)                                                                                  
print('\n A diferenção entre o Limitante Inferior e a Melhor Solução é de:', (objective_function(THE_BEST_SOLUTION)/objective_function(LOWER_LIMIT)))                                                                                  