#Modulo Datetime do Python
from datetime import datetime

now = datetime.now()

#Dicionario do Limitante Inferior
LOWER_LIMIT = {}

#Lista das Usinas de Energia por Região
AV = ['AGV']
BBB = ['BAB','BAR']
NAPI = ['NAV','PRO','IBI']
RJM = ['SJS']
RMG = ['MOG']
RP = ['CAC','EUC','LMO']

#Horizonte de Planejamento
T = 60

############################--ARQUIVO USINAS--###############################
file = open ('powerplant.txt', 'r')

#Dicionario de Usinas
G = {}
powerplant = None

for line in file:
    
    #Salva uma linha para cada posicAo da lista values#
    values = line.split()

    if values[0] == '#':
        continue
    #end if
    
    #Salva uma Usina
    powerplant = values[1]

    #Mapeia Usinas em suas areas
    G[powerplant] = values[2]

file.close()

############################--ARQUIVO USINAS--########################-END-##


###########################--ARQUIVO PROJETO--###############################
file = open('projects.txt','r')

category = {}
costs = {}
generator_unit= {}
halting_duration = {}
halting_month = {}
initial_month = {}
maintenance = {}
mandatory_project = {}
project = None
project_duration = {}
project_powerplant = {}
risk_management_projects = {}
total_cost = {}

for line in file:

    #Salva uma linha para cada posição da lista values#
    values = line.split()

    if values[0] == '#':

        continue

    #end if

    #Salva um projeto
    project = (int(values[0]))

    #Mapeia todos os projetos no mes 1 para o calculo do Limitante Inferior
    LOWER_LIMIT[project] = int(1)

    #Salva o mes inicial de cada projeto#
    initial_month[project] = int(values[1])

    #Salva o custo de cada mes de execucAo do projeto#
    costs[project] = [ float(x) for x in values[9:] ]

    #Calcula o total de recursos na execucAo do projeto#
    total_cost[project] = sum([ float(x) for x in values[9:]])

    #Conta os meses de execucAo de um projeto#
    project_duration[project] = len([ float(x) for x in values[9:]])

    #Dicionario de categorias de recursos.
    if values[2] == 'GNR':
        #Mapeia projetos em meses
        mandatory_project[project] = int(values[1])
    else:
        risk_management_projects[project] = int(values[1])
    #end if

    #Salva a categoria de recurso do Projeto
    category[project] = values[8]
  
    #Dicionario de projetos de manutencAo.
    if values[3] != 'N':
        
        maintenance[project] = values[3]

        halting_month[project] = values[6]

        halting_duration[project] = values[7]

        generator_unit[project] = values[5]
        
        project_powerplant[project] = values[4]
    #end if

#end for

file.close()
###########################--ARQUIVO PROJETO--########################-END-##


#####################--ARQUIVO PONTOS DE ATENÇÃO--###########################
file = open ('warning_points.txt', 'r')

risk_value = [-1]
intolerable_warning_point = {}

#########--TABELA HASH DE PONTO DE ATENÇÃO E SEU GRUPO DE PROJETOS--#########
#Dicionario de Pontos de ATENÇÃO#
warning_points_hash = {}
warning_point_risk = {}

for line in file:

    values = line.split()

    if values[0] == '#':

        continue

    #end if

    #Recebe um ponto de ATENÇÃO
    warning_points = int(values[0])
    
    #Cria uma lista de projetos
    project_list = [int(element) for element in values[4:]]

    #Cada ponto de ATENÇÃO na chave aponta para um grupo de projetos que o controla
    warning_points_hash[warning_points] = project_list

    #Lista que recebe o valor do risco de cada ponto de ATENÇÃO
    risk_value.append(int(values[1]))
    warning_point_risk[warning_points] = int(values[1])

    #Cria um dicionario com os pontos de ATENÇÃO intoleraveis
    if values[2] == 'I':
        intolerable_warning_point[warning_points] = int(values[3])
    #end if
#end for
risk_value_total = sum(risk_value)

###################--CALCULO DA PORcAO DE RISCO--############################
risk_part = [] 

#Para cada chave do hask warning_points_hash a lista risk_part recebe o valor do risco do wp divido pelo numero de projetos
risk_part = [risk_value[wp]/len(warning_points_hash[wp]) for wp in warning_points_hash.keys()]
###################--CALCULO DA PORcAO DE RISCO--#####################-END-##

#########--TABELA HASH DE PONTO DE ATENÇÃO E SEU GRUPO DE PROJETOS--##-END-##


########--TABELA HASH DE PROJETO E PONTOS DE ATENÇÃO QUE CONTROLAM--#########
#Dicionario de Projetos que mapeia projetos em pontos de ATENÇÃO#
project_hash = {}

#Acessa as chaves do dicionario warning_points_hash#
for W in warning_points_hash.keys():

    #Salva os identificadores de projetos contido nas chaves#
    project_list = warning_points_hash[W]

    #para cada projeto da project_list
    for p in project_list:
        
        #Se p etiver contido no dicionario
        if p in project_hash.keys():

            #Lista temporaria de pontos de ATENÇÃO#
            temporary_list = project_hash[p] 

            temporary_list.append(W)
            project_hash[p] = temporary_list

        else:
            project_hash[p] = [int(W)]
        #end if
    #end for
#end for

########--TABELA HASH DE PROJETO E PONTOS DE ATENÇÃO QUE CONTROLAM--##-END-##

################--SOMA DA PORcAO DE RISCO DE CADA PROJETO--##################
project_risk_total = {}

#Project_hash mapeia projetos em suas listas de pontos de ATENÇÃO
for project in project_hash.keys():

    project_risk_total[project] = sum([risk_part[x] for x in project_hash[project]])

#end for
################--SOMA DA PORcAO DE RISCO DE CADA PROJETO--###########--END##
    
file.close()
#####################--ARQUIVO PONTOS DE ATENÇÃO--####################-END-##

file_CAPEX =  open("CAPEX.txt", "r")

resources = {}
resources['CAPEX'] = {}

for line in file_CAPEX:
    
    #Salva uma linha para cada posicAo da lista values#
    values = line.split()

    if values[0] == '#':
        continue
    #end if

    resources['CAPEX'][int(values[0])] = float(values[1])
#end for
file_CAPEX.close()

file_OPEX =  open("OPEX.txt", "r")

resources['OPEX'] = {}

for line in file_OPEX:
    
    #Salva uma linha para cada posicAo da lista values#
    values = line.split()

    if values[0] == '#':
        continue
    #end if

    resources['OPEX'][int(values[0])] = float(values[1])
#end for
file_OPEX.close()

def save_solution(P):

    file_solutions_found = open('solutions_found.txt','w')
    file_all_solutions = open('all_solutions.txt','a')

    file_all_solutions.write('#')
    file_all_solutions.write('>')
    file_all_solutions.write(str(now.year))
    file_all_solutions.write('/')
    file_all_solutions.write(str(now.month))
    file_all_solutions.write('/')
    file_all_solutions.write(str(now.day))
    file_all_solutions.write('\t')
    file_all_solutions.write(str(now.hour))
    file_all_solutions.write(':')
    file_all_solutions.write(str(now.minute))
    file_all_solutions.write(':')
    file_all_solutions.write(str(now.second))
    file_all_solutions.write('\n\n')

    #Arquivo temporario das soluções
    file_solutions_found.write(str(P))
    file_solutions_found.write('\n')

    #Arquivo de log de todas as soluções
    file_all_solutions.write(str(P))
    file_all_solutions.write('\n')

    file_all_solutions.write('-END--------------------------------------------------------------------------------------\n\n')
    file_all_solutions.close()
    file_solutions_found.close()

#end def
